//////////////////////////////////////////////////////////////////////////////
//
// $Id: genericserver.C,v 1.2 2001/07/21 14:34:38 assman Exp $
//
// $Log: genericserver.C,v $
// Revision 1.2  2001/07/21 14:34:38  assman
// Added the generic server to the library tree
//
// Revision 1.1  2001/06/24 14:30:42  assman
// added cvs headers
//
//////////////////////////////////////////////////////////////////////////////

#include <genericserver>

GenericServer::~GenericServer() {
  int n=0;
  Connection_Handler *c;
  
  while (_incoming_data.size()>0) {
    cout << "WARNING: an't process " << n 
	 << " element. Dropping it" << endl;

    c = _incoming_data[0];
    _incoming_data.erase(_incoming_data.begin());
    //_incoming_data.pop();
    delete (c);
    n++;
  }
  
  while (_allowfrom_filter.size()>0) {
    _allowfrom_filter.erase(_allowfrom_filter.begin());
  }
  
  if (logger != NULL) delete(logger);
}

void GenericServer::insert_allowfrom_element(string data) {
  _allowfrom_filter.push_back(data);
}

//////////////////////////////////////////////////////////////////////////////
//
// workerdispatchthread
//
//////////////////////////////////////////////////////////////////////////////

void GenericServer::_workerdispatchthread(void) {
  Connection_Handler *c;
  Address a;
  long pet = 0;

  while (1) {
    

    c = server->accept();
    if (c == NULL) {
      logger->log(LOGGER::LEVEL::WARNING,"Error receiving new connection");
      continue;
    }
    a = c->address();

    logger->log(LOGGER::LEVEL::INFO,"Incoming Connection From: %s:%d",
    		a.host().c_str(),a.port());




    _incoming_lock.lock();

    pet++;
    if ((pet % 100) == 0) 
      cout << "Accept: " << pet << " Size: " << _incoming_data.size() << endl;
    
    _incoming_data.push_back(c);
    _incoming_lock.release();

    _th_sync.post(); // increment sem counter 

    //    cout << _th_sync.value() << endl;
    // _th_sync.post(); // we have some to release here we fail !

    //
    // wait for free threads
    //

    //    _th_avail_lock.lock();
    //if (_th_avail == 0) {
    //	cout << "waitting for free threads" << endl;
    //	_th_avail_lock.wait();
    //}
    //_th_avail_lock.release();

    //_pth_lock.release(); // release another thread

  }
}

