//////////////////////////////////////////////////////////////////////////////
//
// $Id: genericserver.h,v 1.2 2001/07/21 14:34:38 assman Exp $
// 
// Started: 15/May/2001 (Tue 12:08)
//
// $Log: genericserver.h,v $
// Revision 1.2  2001/07/21 14:34:38  assman
// Added the generic server to the library tree
//
// Revision 1.1  2001/06/24 14:30:42  assman
// added cvs headers
//
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __GENERIC_ITM_SERVER_H__
#define __GENERIC_ITM_SERVER_H__

#include <netthreadedserver>
#include <errormgmt>
#include <regexpressions>
#include <logger>

  class GenericServer: public NetThreadedServer {

  public:

      GenericServer(int maxth, int block, 
		    int sec_timeout=60, 
		    int msec_timeout=0, 
		    int reuse_socket=1, 
		    int socket_queue=5, 
		    int type= TCP,
		    int buffersz=2048):
	
	NetThreadedServer(maxth, block, 
			  sec_timeout, msec_timeout,
			  reuse_socket, socket_queue, type ) {
	  
	  logger = NULL;
	  _buff_sz = buffersz;
	  _count = 0;
    }

    virtual ~GenericServer();

    void setDBinfo(string host, string dbname, 
		   string user, string password,
		   int port=5432) {
      _dbhost = host;
      _dbname = dbname;
      _dbuser = user;
      _dbpass = password;
      _dbport = port;
    }

    virtual void *_dispatchthread(void) = 0;
    virtual void _workerdispatchthread(void);
  
    void insert_allowfrom_element(string data);

    void clear_allowfrom_db(void) {
      _allowfrom_filter.erase(_allowfrom_filter.begin(),
			      _allowfrom_filter.end());
    }

    Logger  *logger;

    //
    // for support reload the configuration when a SIG_HUP happen
    //

    void work_lock(void) { _work_lock.lock(); }
    void work_release(void) { _work_lock.release(); }

        
  protected:

    vector<string> _allowfrom_filter;
      
    int _buff_sz;

    Lock  _clock;
    long  _count;

    string _dbhost;
    string _dbname;
    string _dbuser;
    string _dbpass;
    int    _dbport;
  }; 

#endif
